// MFCExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MFCExample.h"
#include "MFCExampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "../evaLayout/EvaFile.h"

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
   CAboutDlg();

// Dialog Data
   //{{AFX_DATA(CAboutDlg)
   enum { IDD = IDD_ABOUTBOX };
   //}}AFX_DATA

   // ClassWizard generated virtual function overrides
   //{{AFX_VIRTUAL(CAboutDlg)
   protected:
   virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

   afx_msg void OnSize(UINT nType, int cx, int cy);
   //}}AFX_VIRTUAL

// Implementation
protected:
   //{{AFX_MSG(CAboutDlg)
   //}}AFX_MSG
   DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
   //{{AFX_DATA_INIT(CAboutDlg)
   //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   //{{AFX_DATA_MAP(CAboutDlg)
   //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
   //{{AFX_MSG_MAP(CAboutDlg)
      // No message handlers
   //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMFCExampleDlg dialog

CMFCExampleDlg::CMFCExampleDlg(CWnd* pParent /*=NULL*/)
   : CDialog(CMFCExampleDlg::IDD, pParent)
     , currentLayIndx(0)
{
   //{{AFX_DATA_INIT(CMFCExampleDlg)
      // NOTE: the ClassWizard will add member initialization here
   //}}AFX_DATA_INIT
   // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
   m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFCExampleDlg::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   //{{AFX_DATA_MAP(CMFCExampleDlg)
      // NOTE: the ClassWizard will add DDX and DDV calls here
   //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMFCExampleDlg, CDialog)
   //{{AFX_MSG_MAP(CMFCExampleDlg)
   ON_WM_SYSCOMMAND()
   ON_WM_PAINT()
   ON_WM_QUERYDRAGICON()
   ON_WM_SIZE()
   ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
   //}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMFCExampleDlg message handlers

BOOL CMFCExampleDlg::OnInitDialog()
{
   CDialog::OnInitDialog();

   // Add "About..." menu item to system menu.

   // IDM_ABOUTBOX must be in the system command range.
   ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
   ASSERT(IDM_ABOUTBOX < 0xF000);

   CMenu* pSysMenu = GetSystemMenu(FALSE);
   if (pSysMenu != NULL)
   {
      CString strAboutMenu;
      strAboutMenu.LoadString(IDS_ABOUTBOX);
      if (!strAboutMenu.IsEmpty())
      {
         pSysMenu->AppendMenu(MF_SEPARATOR);
         pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
      }
   }

   // Set the icon for this dialog.  The framework does this automatically
   //  when the application's main window is not a dialog
   SetIcon(m_hIcon, TRUE);       // Set big icon
   SetIcon(m_hIcon, FALSE);      // Set small icon


   prepareLayout ();
   linkLayout ();
   switchLayout ();

   return TRUE;  // return TRUE  unless you set the focus to a control
}

afx_msg void CMFCExampleDlg::OnSize(UINT nType, int cx, int cy)
{
   CDialog::OnSize(nType, cx, cy);

   // ---- EvaLayout: remake the layout on each resize
   //
   showLayout ();
}


void CMFCExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
   if ((nID & 0xFFF0) == IDM_ABOUTBOX)
   {
      CAboutDlg dlgAbout;
      dlgAbout.DoModal();
   }
   else
   {
      CDialog::OnSysCommand(nID, lParam);
   }
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMFCExampleDlg::OnPaint()
{
   if (IsIconic())
   {
      CPaintDC dc(this); // device context for painting

      SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

      // Center icon in client rectangle
      int cxIcon = GetSystemMetrics(SM_CXICON);
      int cyIcon = GetSystemMetrics(SM_CYICON);
      CRect rect;
      GetClientRect(&rect);
      int x = (rect.Width() - cxIcon + 1) / 2;
      int y = (rect.Height() - cyIcon + 1) / 2;

      // Draw the icon
      dc.DrawIcon(x, y, m_hIcon);
   }
   else
   {
      CDialog::OnPaint();
   }
}



// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMFCExampleDlg::OnQueryDragIcon()
{
   return (HCURSOR) m_hIcon;
}

void CMFCExampleDlg::OnButton1()
{
   switchLayout();
}


void CMFCExampleDlg::prepareLayout ()
{
   // EVA Layout --------------------------------
   // Load layoutInfo in two different ways :
   //
   //    If the file WinLayouts.eva is found then the layout Info's
   //    contained in the unit #data# are loaded. Otherwise
   //    we build here two harcoded Eva layout Info's.
   //

   EvaFile efi;
   if (! efi.load(layoutArray, "ConfigLayouts.eva", "data"))
   {
      MessageBox("Working with two harcoded layoutInfo's\nbecause file ConfigLayouts.eva is not found", "Warning", MB_OK);

      // create two Eva's on this EvaUnit
      //
      layoutArray.add (Eva ("first"));
      layoutArray.add (Eva ("second"));

      // get the references to the Eva's to fill them
      // (note that eunit[0] and eunit[1] could be used as well)
      //
      Eva & layI1 = layoutArray["first"];

      layI1.addLine (EvaLine ("EvaLayout, 10, 10, 5, 5"));
      layI1.addLine (EvaLine (" zzz,         ,   X      ,  A     ,"));
      layI1.addLine (EvaLine ("    , label1  , edit1    , -      ,"));
      layI1.addLine (EvaLine ("    , label2  , edit2    , -      ,"));
      layI1.addLine (EvaLine ("    ,         , memo     , boton1 ,"));
      layI1.addLine (EvaLine ("    ,         ,   +      , boton2 ,"));
      layI1.addLine (EvaLine ("   X ,         ,   +      ,       ,"));

      Eva & layI2 = layoutArray["second"];

      layI2.addLine (EvaLine ("EvaLayout, 10, 10, 5, 5"));
      layI2.addLine (EvaLine ("xxx,    A     ,    A    , X       ,  "));
      layI2.addLine (EvaLine ("  A, boton1   , label1  , edit1   ,  "));
      layI2.addLine (EvaLine ("  A, boton2   , label2  , edit2   ,  "));
      layI2.addLine (EvaLine ("  A,          , label3  , edit3   ,  "));
      layI2.addLine (EvaLine ("  A, memo     ,   -     ,    -    ,  "));
      layI2.addLine (EvaLine ("  X,  +       ,         ,         ,  "));

      // to export the harcoded EvaUnit ...
      //
      // efi.saveSingleUnit (eunit, "hardcoded.eva");
   }

   if (layoutArray.size () == 0)
   {
      MessageBox("Error there are no layouts loaded!", "Error", MB_OK);
      PostQuitMessage(0);
      //EndDialog (hDlg, LOWORD(wParam));
   }
}

void CMFCExampleDlg::linkLayout ()
{
   // ---- EvaLayout: Associate all components with the logic names
   //                 of the layout info or layouts infos. Usually made only once
   //                 but all components from all possible layouts has to be declared here.
   //
   gaston.addComponent("lista",  GetDlgItem (IDC_LIST1)->GetSafeHwnd());
   gaston.addComponent("memo",   GetDlgItem (IDC_MEMO)->GetSafeHwnd());
   gaston.addComponent("combo",  GetDlgItem (IDC_COMBO1)->GetSafeHwnd());

   gaston.addComponent("label1", GetDlgItem (IDC_LABEL1)->GetSafeHwnd());
   gaston.addComponent("label2", GetDlgItem (IDC_LABEL2)->GetSafeHwnd());
   gaston.addComponent("label3", GetDlgItem (IDC_LABEL3)->GetSafeHwnd());
   gaston.addComponent("label4", GetDlgItem (IDC_LABEL4)->GetSafeHwnd());

   gaston.addComponent("boton1", GetDlgItem (IDC_BUTTON1)->GetSafeHwnd());
   gaston.addComponent("boton2", GetDlgItem (IDC_BUTTON2)->GetSafeHwnd());
   gaston.addComponent("boton3", GetDlgItem (IDC_BUTTON3)->GetSafeHwnd());
   gaston.addComponent("boton4", GetDlgItem (IDC_BUTTON4)->GetSafeHwnd());

   gaston.addComponent("edit1",  GetDlgItem (IDC_EDIT1)->GetSafeHwnd());
   gaston.addComponent("edit2",  GetDlgItem (IDC_EDIT2)->GetSafeHwnd());
   gaston.addComponent("edit3",  GetDlgItem (IDC_EDIT3)->GetSafeHwnd());
   gaston.addComponent("edit4",  GetDlgItem (IDC_EDIT4)->GetSafeHwnd());
   // ================================================================
}

/**
   // ---- EvaLayout: method for MFC to recalculate the layout
   //
   call this function after setting a new layout
   or resizing the window
*/
void CMFCExampleDlg::showLayout ()
{
   CRect rect;
   GetClientRect(&rect);

   // ---- EvaLayout: do the real job
   //
   gaston.doLayout(rect.Width(), rect.Height());

   // for example: just invalidate sometimes to avoid flickering
   //              if Invalidate is never called then in some situations
   //              the components are wrong painted
   static int sometimes = 0;
   if (sometimes ++ > 40)
   {
      sometimes = 0;
      Invalidate ();
   }
}

void CMFCExampleDlg::switchLayout ()
{
   // ---- EvaLayout: set the layout info into the manager. If only one layout is needed
   //                 it is enough to do it just once. But if more layouts are to be handled
   //                 then this is the proper method to switch the layout

   // switch to next layout ...
   //
   if (currentLayIndx >= layoutArray.size())
      currentLayIndx = 0;
   gaston.setLayout(layoutArray[currentLayIndx ++]);
   //Invalidate ();

   showLayout ();
}


