/*
Eva library C++ (see java package de.elxala.Eva and EvaFormat.PDF)
Copyright (C) 2005  Alejandro Xalabarder Aulet

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
   EvaLine.cpp
   author Alejandro Xalabarder

   @todo General review, document it in english and make it conform with Eva specification 1.1
*/

#include "EvaLine.h"
#include <cstring>

std::string EvaLine::NIL_string;

EvaLine::EvaLine (const char * sLin)
{
   Cadena cadLin (sLin);
   cadLin.toVector (arr_Column);
}

void EvaLine::clear ()
{
   NIL_string = "";
   arr_Column.clear ();
}

void EvaLine::setValue (const char * sVal, int ncol)
{
   if (ncol < 0) return;
   if (ensureCol (ncol))
      arr_Column[ncol] = sVal;
}

bool EvaLine::ensureCol (const int ncol)
{
   // insert columns ?
   while (cols() <= ncol && addValue ());
   return (ncol < cols());
}

bool EvaLine::addValue (const char * sVal)
{
   if (strlen(sVal) == 0)
      arr_Column.push_back ("");
   else arr_Column.push_back (sVal);
   // catch exception ...
   return true;
}

/**
   Retorna la variable de la columna 'ncol' o null
*/
std::string & EvaLine::get (const int ncol)
{
   if (ncol < cols () && ncol >= 0)
      return arr_Column [ncol];
   else {
      NIL_string = ""; // ensure it is void
      return NIL_string;
   }
}

std::string EvaLine::toString ()
{
   Cadena cad;
   cad.setVector (arr_Column);
   return std::string (cad.o_str);
}
