/*
Eva library C++ (see java package de.elxala.Eva and EvaFormat.PDF)
Copyright (C) 2005  Alejandro Xalabarder Aulet

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
   EvaUnit.cpp
   author Alejandro Xalabarder

   @todo General review, document it in english and make it conform with Eva specification 1.1
*/
#include "EvaUnit.h"

Eva EvaUnit::NIL_Eva;


bool EvaUnit::add (const Eva & nova)
{
   if (indxEva(nova.Nombre.c_str ()) != -1) return false;
   lis_Evas.push_back (nova);
   return true;
}

int EvaUnit::indxEva (const char * Nom)
{
   for (int ii = 0; ii < size (); ii ++)
      if (lis_Evas[ii].Nombre == Nom)
         return ii;
   return -1;
}

void EvaUnit::clear ()
{
   lis_Evas.clear ();
   NIL_Eva.clear ();
   Nombre = "";
}

std::string EvaUnit::toString ()
{
   std::string str ("#" + Nombre + "#\n\n");

   for (int ii = 0; ii < size (); ii ++)
      str.append (lis_Evas[ii].toString ());

   return std::string (str);
}

Eva & EvaUnit::getEva (const char * nameEva)
{
   int indx = indxEva (nameEva);
   if (indx != -1)
      return lis_Evas[indx];
   {
      NIL_Eva.clear ();
      return NIL_Eva;
   }
}

std::string & EvaUnit::getValue (const char * nameEva, int nrow, int ncol)
{
   return getEva (nameEva) [nrow] [ncol];
/* int indx = indxEva (nameEva);
   if (indx != -1)
      return lis_Evas[indx].getValue (nrow, ncol);
   else {
      EvaLine::NIL_string.clear ();
      return EvaLine::NIL_string;
   }
*/
}

bool EvaUnit::ensureEva (const char * nameEva)
{
   int indx = indxEva (nameEva);

   // ensure existency
   if (indx == -1) {
      add (Eva (nameEva));
      indx = indxEva (nameEva);
   }
   return (indx != -1);
}

Eva & EvaUnit::getSomeHowEva (const char * evaName)
{
   if (ensureEva (evaName)) {
      int indx = indxEva (evaName);
      return (indx == -1) ? NIL_Eva : lis_Evas[indx];
   }
   else {
      NIL_Eva.clear ();
      return NIL_Eva;
   }
}

void EvaUnit::setValue (const char * evaName, const char * value, int row, int col)
{
   getSomeHowEva (evaName).setValue (value, row, col);
}

Eva & EvaUnit::operator [] (const int indxEva)
{
   if (indxEva >= 0 && indxEva < size ())
      return lis_Evas[indxEva];
   else {
      NIL_Eva.clear ();
      return NIL_Eva;
   }
}

Eva & EvaUnit::operator [] (const char *evaName)
{
   return getEva (evaName);
}
